var cellArr0 	= new Array();	//hidden cells used for mouse events trapping only
var cellArr1 	= new Array();	//cell text first row
var cellArr2 	= new Array();	//cell text second row
var cellArr3 	= new Array();	//cell text third row
var arrValBack	= new Array();	//array of board arrayes, used to store previous board states for undo
var arrDigitButtons	= new Array();
var digitPad;
var closeDigitPadButton;

var boolBoardContainsInvalidValues = false;

var intSelectedCell = -1;
var intUndoIndex = 0;

var COLOR_BLOCKED_CELL	= "#ff0000";
var COLOR_NORMAL_CELL	= "#5e402c";

var VERSION_URL = "http://www.sudohelper.com/widget/version.txt";
var INI_FILE = "sudo.ini";
var CURRENT_VERSION = "1.1.1";

checkForUpdates();
init();


  
//initialize
function init()
{
	for (i=0;i<81;i++)
	{
		//initialize cells l&f
		
		cellArr1[i] = new Text();
		cellArr1[i].hOffset 	= 50+indexToColumn(i)*45;
		cellArr1[i].vOffset 	= indexToRow(i, 9)*45;
		cellArr1[i].alignment 	= "center";
		cellArr1[i].font 		= "Arial Black";
		cellArr1[i].opacity		= 220;
		cellArr1[i].zOrder		= 1;
		
		cellArr2[i] = new Text();
		cellArr2[i].hOffset 	= 50+indexToColumn(i)*45;
		cellArr2[i].vOffset 	= indexToRow(i, 9)*45;
		cellArr2[i].alignment 	= "center";
		cellArr2[i].font 		= "Arial Black";
		cellArr2[i].opacity		= 220;
		cellArr2[i].zOrder		= 1;

		cellArr3[i] = new Text();
		cellArr3[i].hOffset 	= 50+indexToColumn(i)*45;
		cellArr3[i].vOffset 	= indexToRow(i)*45;
		cellArr3[i].alignment 	= "center";
		cellArr3[i].font 		= "Arial Black";
		cellArr3[i].opacity		= 220;
		cellArr3[i].zOrder		= 1;

		cellArr0[i] = new Text();
		cellArr0[i].hOffset 	= indexToColumn(i)*48+54;
		cellArr0[i].vOffset 	= indexToRow(i)*48+68;
		cellArr0[i].width 		= 48;
		cellArr0[i].height		= 48;
		cellArr0[i].alignment 	= "center";
		cellArr0[i].font 		= "Arial Black";
		cellArr0[i].opacity		= 1;
		cellArr0[i].zOrder		= 1;
		cellArr0[i].data 		= "X";
		cellArr0[i].size 		= 48;

		cellArr0[i].onMouseDown = "cellClicked(" + i + ");";
		
		//initialize values array default values
		setCellText(i, "123456789");
		
		initDigitButtons();
	}
}

//initialize array of digit buttons (images)
function initDigitButtons()
{
	for(k=0;k<9;k++)
	{
		arrDigitButtons[k] = new Image();
		arrDigitButtons[k].src	= "Images/digit_pad.png";
		var y = Math.floor(k/3)*52 + 15;
		var x = (k - (Math.floor(k/3)*3)) * 52 +20;
		var width = 52;
		var height = 52;
		arrDigitButtons[k].clipRect="" + x + "," + y + "," + width + "," + height;
		arrDigitButtons[k].onMouseDown = "digitPadClick(" + (k+1) + ")";
		arrDigitButtons[k].opacity = 0;
	}
	
	digitPad = new Image();
	digitPad.src = "Images/digit_pad.png";
	digitPad.opacity = 0;
	
	closeDigitPadButton = new Image();
	closeDigitPadButton.src = "Images/close_digit_pad.png";
	closeDigitPadButton.opacity = 0;
	closeDigitPadButton.onMouseDown = "closeDigitPad()";
	
	
	
}

//set cell text.
//adjusts digits size and location according to number of digits
//(done my best)
function setCellText(_cellIndex, _value)
{
	//default location 
	cellArr1[_cellIndex].vOffset = indexToRow(_cellIndex)*48+68;
	cellArr1[_cellIndex].hOffset = indexToColumn(_cellIndex)*48+54;
	cellArr2[_cellIndex].hOffset = indexToColumn(_cellIndex)*48+54;
	cellArr3[_cellIndex].hOffset = indexToColumn(_cellIndex)*48+54;

	cellArr1[_cellIndex].color 		= COLOR_NORMAL_CELL;
	cellArr2[_cellIndex].color 		= COLOR_NORMAL_CELL;
	cellArr3[_cellIndex].color 		= COLOR_NORMAL_CELL;
	
	if (_value.length == 9)
	{
		//show nothing
		cellArr1[_cellIndex].size = 0;
		cellArr2[_cellIndex].size = 0;
		cellArr3[_cellIndex].size = 0;

		cellArr1[_cellIndex].data = "";
		cellArr2[_cellIndex].data = "";
		cellArr3[_cellIndex].data = "";
	}
	else if (_value.length == 8)
	{
		cellArr1[_cellIndex].size = 16;
		cellArr2[_cellIndex].size = 16;
		cellArr3[_cellIndex].size = 16;

		cellArr1[_cellIndex].vOffset -= 27;
		cellArr2[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 14;
		cellArr3[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 28;

		cellArr1[_cellIndex].data = _value.charAt(0) + " " + _value.charAt(1) + " " + _value.charAt(2);
		cellArr2[_cellIndex].data = _value.charAt(3) + "    " + _value.charAt(4);
		cellArr3[_cellIndex].data = _value.charAt(5) + " " + _value.charAt(6) + " " + _value.charAt(7);
	}
	else if (_value.length == 7)
	{
		cellArr1[_cellIndex].size = 17;
		cellArr2[_cellIndex].size = 17;
		cellArr3[_cellIndex].size = 17;

		cellArr1[_cellIndex].vOffset -= 27;
		cellArr2[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 14;
		cellArr3[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 28;

		cellArr1[_cellIndex].data = _value.charAt(0) + " " + _value.charAt(1) + " " + _value.charAt(2);
		cellArr2[_cellIndex].data = _value.charAt(3);
		cellArr3[_cellIndex].data = _value.charAt(4) + " " + _value.charAt(5) + " " + _value.charAt(6);
	}
	else if (_value.length == 6)
	{
		cellArr1[_cellIndex].size = 17;
		cellArr2[_cellIndex].size = 17;
		cellArr3[_cellIndex].size = 0;
		
		cellArr1[_cellIndex].vOffset -= 24;
		cellArr2[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 22;

		cellArr1[_cellIndex].data = _value.charAt(0) + " " + _value.charAt(1) + " " + _value.charAt(2);
		cellArr2[_cellIndex].data = _value.charAt(3) + " " + _value.charAt(4) + " " + _value.charAt(5);
		cellArr3[_cellIndex].data = "";
	}
	else if (_value.length == 5)
	{
		cellArr1[_cellIndex].size = 21;
		cellArr2[_cellIndex].size = 21;
		cellArr3[_cellIndex].size = 21;
		
		cellArr1[_cellIndex].vOffset -= 24;
		cellArr2[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 12;
		cellArr3[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 25;

		cellArr1[_cellIndex].data = _value.charAt(0) + "  " + _value.charAt(1);
		cellArr2[_cellIndex].data = _value.charAt(2);
		cellArr3[_cellIndex].data = _value.charAt(3) + "  " + _value.charAt(4);
	}
	else if (_value.length == 4)
	{
		cellArr1[_cellIndex].size = 24;
		cellArr2[_cellIndex].size = 24;
		cellArr3[_cellIndex].size = 0;
		
		cellArr1[_cellIndex].vOffset -= 20;
		cellArr2[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 22;

		cellArr1[_cellIndex].data = _value.charAt(0) + " " + _value.charAt(1);
		cellArr2[_cellIndex].data = _value.charAt(2) + " " + _value.charAt(3);
		cellArr3[_cellIndex].data = "";
	}
	else if (_value.length == 3)
	{
		cellArr1[_cellIndex].size = 24;
		cellArr2[_cellIndex].size = 24;
		cellArr3[_cellIndex].size = 0;
		
		cellArr1[_cellIndex].vOffset -= 20;
		cellArr2[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset + 22;

		cellArr1[_cellIndex].data = _value.charAt(0) + " " + _value.charAt(1);
		cellArr2[_cellIndex].data = _value.charAt(2);
		cellArr3[_cellIndex].data = "";
	}
	else if (_value.length == 2)
	{
		cellArr1[_cellIndex].size = 30;
		cellArr2[_cellIndex].size = 30;
		cellArr3[_cellIndex].size = 0;
		
		cellArr2[_cellIndex].vOffset = cellArr1[_cellIndex].vOffset - 16;
		cellArr1[_cellIndex].hOffset = cellArr1[_cellIndex].hOffset-10;
		cellArr2[_cellIndex].hOffset = cellArr1[_cellIndex].hOffset+22;

		cellArr1[_cellIndex].data = _value.charAt(0);
		cellArr2[_cellIndex].data =  _value.charAt(1);
		cellArr3[_cellIndex].data = "";
	}
	else if (_value.length == 1)
	{
		cellArr1[_cellIndex].size = 55;
		cellArr2[_cellIndex].size = 0;
		cellArr3[_cellIndex].size = 0;
		
		cellArr2[_cellIndex].vOffset += 70;

		cellArr1[_cellIndex].data = _value.charAt(0);
		cellArr2[_cellIndex].data = "";
		cellArr3[_cellIndex].data = "";
	}
}

function getCellText(_cellIndex)
{
	var str = "" + cellArr1[_cellIndex].data + cellArr2[_cellIndex].data + cellArr3[_cellIndex].data;
	//removes spaces
	while (str.indexOf(" ") != -1)
	{
		str = str.replace(" ","");
	}
	return str == "" ? "123456789" : str;
}

//user selected a new value (digits) to be set to the current selected cell
function digitPadClick(_digit)
{
	backupCurrentBoard();
	cellSetValue(intSelectedCell, ""+_digit);
	setDigitPadOpacity(0);
	setBoardOpacity(235);
}

//whenever a cell clicked  - show a digit (if the board is valid and the cell contains
//more than one digit)
function cellClicked(_index)
{
	if (!boolBoardContainsInvalidValues && getCellText(_index).length > 1 && intSelectedCell==-1)
	{
		setDigitPadOpacity(220);
		setBoardOpacity(180);
		setDigitPadOffset(Math.floor(indexToRow(_index)/3)*150, Math.floor(indexToColumn(_index)/3)*150);
		intSelectedCell = _index;
	}
}

//copies current board into backup board, for undo ability
function backupCurrentBoard()
{
	undo_button.opacity = 220;
	clear_button.opacity = 220;

	var tempArr = new Array();
	for (i=0;i<81;i++)
	{
		tempArr[i] = ""+getCellText(i);
	}
	arrValBack[intUndoIndex] = tempArr;
	intUndoIndex++;
}

//undo last move,
//loads last board state from arrValBack array
function undo()
{
	if (!isDigitButtonShown())
	{
		for(var i=0;i<81;i++)
		{
			setCellText(i, arrValBack[intUndoIndex-1][i]);
		}
		intUndoIndex--;
		undo_button.opacity = intUndoIndex==0 ? 0 : 220;
		clear_button.opacity = intUndoIndex==0 ? 0 : 220;
		boolBoardContainsInvalidValues = false;
	}
}

//clears board to initial state
function clearBoard()
{
	if (!isDigitButtonShown())
	{
		boolBoardContainsInvalidValues = false;
	
		intSelectedCell = -1;
		intUndoIndex = 0;
		
		for(i=0;i<81;i++)
		{
			setCellText(i, "123456789");
		}

		undo_button.opacity = 0;
		clear_button.opacity = 0;
	}
}

function closeDigitPad()
{
	setDigitPadOpacity(0);
	setBoardOpacity(235);
	intSelectedCell = -1; 
}

//set value to a cell:
//sets its text and the values array as well
function cellSetValue(_index, _value)
{
	setCellText(_index, _value);
	cellChangedValue(_index, ""+_value);
	intSelectedCell = -1; 
}

//to be called whenever a cell value is changed,
//set surronding cells value according to new value
function cellChangedValue(_index, _value)
{	
	var cell_row = indexToRow(_index);
	var cell_col = indexToColumn(_index);
	var cell_val = getCellText(_index);
		

	//remove new val from cell's col
	for (var i=0;i<9;i++)
	{
		if (i != cell_col)
		{
			removeNumber(rowColumnToIndex(cell_row, i), cell_val);
		}
	}

	//remove new val from cell's row
	for (var i=0;i<9;i++)
	{
		if (i != cell_row)
		{
			removeNumber(rowColumnToIndex(i, cell_col), cell_val);
		}
	}

	//remove new val from cell's block
	for(var i=0;i<3;i++)
	{
		for (var j=0;j<3;j++)
		{
			var row = Math.floor(cell_row/3)*3 + i;
			var col = Math.floor(cell_col/3)*3 + j;
			if (row!=cell_row && col!=cell_col)
			{
				removeNumber(rowColumnToIndex(row, col), cell_val);
			}
		}
	}
	
	//check to see whether invalid values entered
	for (var i=0;i<9;i++)
	{
		if (i != cell_col)
		{
			var valToCheck = "" + getCellText(rowColumnToIndex(cell_row,i));
			if (valToCheck.indexOf(""+cell_val) != -1)
			{
				colorRow(cell_row);
			}
		}
	}

	for (i=0;i<9;i++)
	{
		if (i != cell_row)
		{
			var valToCheck = "" + getCellText(rowColumnToIndex(i,cell_col));
			if (valToCheck.indexOf(""+cell_val) != -1)
			{
				colorColumn(cell_col);
			}
		}
	}

	for(var i=0;i<3;i++)
	{
		for (var j=0;j<3;j++)
		{
			var row = Math.floor(cell_row/3)*3 + i;
			var col = Math.floor(cell_col/3)*3 + j;
			if (row!=cell_row && col!=cell_col)
			{
				var valToCheck = "" + getCellText(rowColumnToIndex(row,col));
				if (valToCheck.indexOf(""+cell_val) != -1)
				{
					colorBlock(cell_row, cell_col);
				}
			}
		}
	}
}

//removes on digit from a current cell
function removeNumber(_index, _val)
{
	boolRetVal = false;
	
	var boolRetVal = false;
	if (getCellText(_index).length > 1)
	{
		if (getCellText(_index).indexOf(""+_val) != - 1)
		{
			var str = getCellText(_index).replace(_val,"");
			setCellText(_index, str);
			boolRetVal = true;
			
			if (str.length == 1)
			{
				cellChangedValue(_index, str);
			}
		}
	}
	
	return boolRetVal;
}

//color row cells in case on invalid values in a row
function colorRow(_row)
{
	boolBoardContainsInvalidValues = true;
	for (var i=0;i<9;i++)
	{
		cellArr1[rowColumnToIndex(_row,i)].color = COLOR_BLOCKED_CELL;
		cellArr2[rowColumnToIndex(_row,i)].color = COLOR_BLOCKED_CELL;
		cellArr3[rowColumnToIndex(_row,i)].color = COLOR_BLOCKED_CELL;
	}
}

//color column cells in case on invalid values in a column
function colorColumn(_column)
{
	boolBoardContainsInvalidValues = true;
	for (var i=0;i<9;i++)
	{
		cellArr1[rowColumnToIndex(i, _column)].color = COLOR_BLOCKED_CELL;
		cellArr2[rowColumnToIndex(i, _column)].color = COLOR_BLOCKED_CELL;
		cellArr3[rowColumnToIndex(i, _column)].color = COLOR_BLOCKED_CELL;
	}
}

//color block cells (3x3) in case on invalid values in a block
function colorBlock(_row, _col)
{
	boolBoardContainsInvalidValues = true;
	for(var i=0;i<3;i++)
	{
		for (var j=0;j<3;j++)
		{
			var row = Math.floor(_row/3)*3 + i;
			var col = Math.floor(_col/3)*3 + j;
			cellArr1[rowColumnToIndex(row,col)].color = COLOR_BLOCKED_CELL;
			cellArr2[rowColumnToIndex(row,col)].color = COLOR_BLOCKED_CELL;
			cellArr3[rowColumnToIndex(row,col)].color = COLOR_BLOCKED_CELL;
		}
	}
}

//show/hide digit pad
function setDigitPadOpacity(_opacity)
{
	for(i=0;i<9;i++)
	{
		arrDigitButtons[i].opacity	= _opacity;
	}
	digitPad.opacity	= _opacity;
	closeDigitPadButton.opacity	= _opacity;
}

function isDigitButtonShown()
{
	return arrDigitButtons[0].opacity == 220;
}

function setBoardOpacity(_opacity)
{
	board.opacity = _opacity;
	
	for(i=0;i<81;i++)
	{
		cellArr1[i].opacity	= cellArr1[i].opacity == 0 ? 0 : _opacity==235 ? 220 : _opacity;
		cellArr2[i].opacity	= cellArr1[i].opacity == 0 ? 0 : _opacity==235 ? 220 : _opacity;
		cellArr3[i].opacity	= cellArr1[i].opacity == 0 ? 0 : _opacity==235 ? 220 : _opacity;
	}
}

function setDigitPadOffset(_vOffset, _hOffset)
{	
	for(i=0;i<9;i++)
	{
		arrDigitButtons[i].hOffset = _hOffset;
		arrDigitButtons[i].vOffset = _vOffset;
	}
	digitPad.hOffset = _hOffset;
	digitPad.vOffset = _vOffset;
	closeDigitPadButton.hOffset = _hOffset+172;
	closeDigitPadButton.vOffset = _vOffset-6;
}


// helper methods (_size = array width = array hight)
function indexToRow(_index)
{	
	return Math.floor(_index/9);
}

function indexToColumn(_index)
{	
	return _index - (Math.floor(_index/9)*9);	
}

function rowColumnToIndex(_row, _column)
{
	return _row*9 + _column;
}

/*
*/
function checkForUpdates()
{
	var dateCurrentDate = new Date();
	var dateCurrentMonth = dateCurrentDate.getMonth();

	var strStored = filesystem.readFile( INI_FILE);
	if (strStored==null)
	{
		filesystem.writeFile( INI_FILE, ""+new Date() );
		strStored = filesystem.readFile( INI_FILE);
	}
	var dateStoredDate = new Date(strStored);
	var dateStoredMonth = dateStoredDate.getMonth();

	//check for update if the current month
	//is different from the file stores month (yes, i know this is not a perfect algrorithm)
	if (dateCurrentMonth != dateStoredMonth)
	{
		var url = new URL();
		url.location = VERSION_URL;
		contents = url.fetch();

		var new_version_number = contents.substring(0, contents.indexOf("#"));
		var new_version_text = contents.substring(contents.indexOf("#")+1);

		if (""+new_version_number != "")
		{
			if (!new_version_number.equals(CURRENT_VERSION))
			{
				var answer = alert("New version " + new_version_number + " is available." + "\n\nThis version includes the following changes:\n" +new_version_text + "\n\nWould you like to download it now ?", "Yes", "No"); 

				if (answer == 1)
				{
					openURL("http://www.sudohelper.com/widget");
				}
			}
		}
	}
	else
	{
		//see you next month
	}
}